# Class VulkanCommandBufferBeginInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanCommandBufferBeginInfo

All Implemented Interfaces:
  `VulkanCommandBufferBeginInfoType`

public final class VulkanCommandBufferBeginInfo extends Object implements VulkanCommandBufferBeginInfoType
Structure specifying parameters of a command.

See Also:
  - "VkCommandBufferBeginInfo"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanCommandBufferBeginInfo.Builder`
  Builds instances of type `VulkanCommandBufferBeginInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanCommandBufferBeginInfo.Builder`
  `builder()`
  Creates a builder for `VulkanCommandBufferBeginInfo`.
  `static VulkanCommandBufferBeginInfo`
  `copyOf(VulkanCommandBufferBeginInfoType instance)`
  Creates an immutable copy of a `VulkanCommandBufferBeginInfoType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanCommandBufferBeginInfo` that have equal attribute values.
  `Set<VulkanCommandBufferUsageFlag>`
  `flags()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `flags`.
  `static VulkanCommandBufferBeginInfo`
  `of(Iterable<VulkanCommandBufferUsageFlag> flags)`
  Construct a new immutable `VulkanCommandBufferBeginInfo` instance.
  `static VulkanCommandBufferBeginInfo`
  `of(Set<VulkanCommandBufferUsageFlag> flags)`
  Construct a new immutable `VulkanCommandBufferBeginInfo` instance.
  `String`
  `toString()`
  Prints the immutable value `VulkanCommandBufferBeginInfo` with attribute values.
  `final VulkanCommandBufferBeginInfo`
  `withFlags(VulkanCommandBufferUsageFlag... elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanCommandBufferBeginInfo`
  `withFlags(Iterable<VulkanCommandBufferUsageFlag> elements)`
  Copy the current immutable object with elements that replace the content of `flags`.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### flags

    public Set<VulkanCommandBufferUsageFlag> flags()
    Specified by:
      `flags` in interface `VulkanCommandBufferBeginInfoType`
    Returns:
      Usage behaviour for the command buffer

  - ### withFlags

    public final VulkanCommandBufferBeginInfo withFlags(VulkanCommandBufferUsageFlag... elements)
    Copy the current immutable object with elements that replace the content of `flags`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withFlags

    public final VulkanCommandBufferBeginInfo withFlags(Iterable<VulkanCommandBufferUsageFlag> elements)
    Copy the current immutable object with elements that replace the content of `flags`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of flags elements to set
    Returns:
      A modified copy of `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanCommandBufferBeginInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `flags`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanCommandBufferBeginInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static VulkanCommandBufferBeginInfo of(Set<VulkanCommandBufferUsageFlag> flags)
    Construct a new immutable `VulkanCommandBufferBeginInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
    Returns:
      An immutable VulkanCommandBufferBeginInfo instance

  - ### of

    public static VulkanCommandBufferBeginInfo of(Iterable<VulkanCommandBufferUsageFlag> flags)
    Construct a new immutable `VulkanCommandBufferBeginInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
    Returns:
      An immutable VulkanCommandBufferBeginInfo instance

  - ### copyOf

    public static VulkanCommandBufferBeginInfo copyOf(VulkanCommandBufferBeginInfoType instance)
    Creates an immutable copy of a `VulkanCommandBufferBeginInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanCommandBufferBeginInfo instance

  - ### builder

    public static VulkanCommandBufferBeginInfo.Builder builder()
    Creates a builder for `VulkanCommandBufferBeginInfo`.

         VulkanCommandBufferBeginInfo.builder()
            .addFlags|addAllFlags(com.io7m.jcoronado.api.VulkanCommandBufferUsageFlag) // flags elements
            .build();

    Returns:
      A new VulkanCommandBufferBeginInfo builder